diff -r 11a8f1275a38 sys/netinet/tcp_syncache.c
--- a/sys/netinet/tcp_syncache.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_syncache.c	Mon Mar 11 02:59:51 2013 +1100
@@ -41,6 +41,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kernel.h>
+#include <sys/endian.h>
 #include <sys/sysctl.h>
 #include <sys/limits.h>
 #include <sys/lock.h>
@@ -54,6 +55,7 @@
 #include <sys/socketvar.h>
 #include <sys/syslog.h>
 #include <sys/ucred.h>
+#include <sys/queue.h>
 
 #include <vm/uma.h>
 
@@ -75,11 +77,15 @@
 #include <netinet6/ip6_var.h>
 #include <netinet6/in6_pcb.h>
 #endif
+
+
 #include <netinet/tcp.h>
 #include <netinet/tcp_fsm.h>
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
 #include <netinet/tcp_syncache.h>
 #ifdef INET6
 #include <netinet6/tcp6_var.h>
@@ -132,6 +138,11 @@
 		*syncookie_lookup(struct in_conninfo *, struct syncache_head *,
 		    struct syncache *, struct tcpopt *, struct tcphdr *,
 		    struct socket *);
+static struct	 socket *syncache_socket_subflow(struct syncache *, struct socket *,
+		    struct mbuf *m, struct sockaddr_in *nam);
+static inline struct inpcb*
+		inp_lookup(struct in_addr *faddr, struct in_addr *laddr, uint16_t fport,
+			uint16_t lport);
 
 /*
  * Transmit the SYN,ACK fewer times than TCP_MAXRXTSHIFT specifies.
@@ -640,7 +651,9 @@
 {
 	struct inpcb *inp = NULL;
 	struct socket *so;
+	struct mpcb *mp;
 	struct tcpcb *tp;
+
 	int error;
 	char *s;
 
@@ -806,9 +819,46 @@
 #endif /* INET */
 	INP_HASH_WUNLOCK(&V_tcbinfo);
 	tp = intotcpcb(inp);
+
+	/* create the multipath control block */
+	mp = mp_newmpcb(inp);
+	mp->master_tcpcb = tp;
+
+	/* put the master flow first in the list of subflows */
+	SLIST_INSERT_HEAD(&mp->tp_list, mp->master_tcpcb, next_subflow);
+
+	mp->subflow_cnt = 1;
+	tp->t_mpcb = mp;
+	/* should have a sysctl to check if we want to enable */
+
 	tp->t_state = TCPS_SYN_RECEIVED;
 	tp->iss = sc->sc_iss;
 	tp->irs = sc->sc_irs;
+
+	if (sc->is_master_subflow) {
+		tp->t_mpcb->direct_map = 1;
+		tp->t_mpcb->ds_map_max = tp->t_mpcb->ds_map_min = tp->t_mpcb->ds_snd_una = sc->sc_iss + 1;
+		tp->t_mpcb->ds_rcv_nxt = sc->sc_irs + 1;
+	}
+
+	/*
+	 * Only need to check for sent_capable as on the passive side if
+	 * this is set then mpc is also set.
+	 */
+	if (sc->sent_capable) {
+		tp->t_mpcb->csum_enabled = sc->csum_enabled;
+		tp->mpc = sc->mpc;
+		tp->sent_capable = 1;
+
+		if (sc->is_master_subflow) {
+			mp_process_local_key(tp->t_mpcb, sc->sc_mp_local_key);
+			mp_process_remote_key(tp->t_mpcb, sc->sc_mp_remote_key);
+		}
+	}
+
+	/* initialise mutex for control block */
+	mtx_init(&mp->mpcb_mutex, "mpcb", NULL, MTX_DEF);
+
 	tcp_rcvseqinit(tp);
 	tcp_sendseqinit(tp);
 	tp->snd_wl1 = sc->sc_irs;
@@ -892,6 +942,165 @@
 	return (NULL);
 }
 
+
+/*
+ * return the master socket for this subflow
+ */
+static struct socket *
+syncache_socket_subflow(struct syncache *sc, struct socket *lso,
+    struct mbuf *m, struct sockaddr_in *nam)
+{
+	struct inpcb *inp;
+	struct mpcb *mp;
+	struct socket *so;
+	struct tcpcb *tp;
+	int error = 0;
+	int token;
+
+	token = sc->sc_mp_token;
+
+	/* Find the mp for the subflow connection token provided */
+	INP_INFO_LOCK_ASSERT(&V_tcbinfo);
+	LIST_FOREACH(inp, &V_tcb, inp_list) {
+		INP_WLOCK(inp);
+		/* Important to skip tcptw structs. */
+		if (!(inp->inp_flags & INP_TIMEWAIT) &&
+			(tp = intotcpcb(inp)) != NULL) {
+			if (tp->mp_active) {
+				if (inp == tp->t_mpcb->master_inpcb
+					&& tp->t_mpcb->local_token == token) {
+					break;
+				}
+			}
+		}
+		INP_WUNLOCK(inp);
+	}
+	KASSERT(inp != NULL,("%s: inp is null\n", __func__));
+
+	/* inp is the master inp at this point */
+	mp = intotcpcb(inp)->t_mpcb;
+
+	/*
+	 * Set the socket to the master socket for the mptcp connection.
+	 * The inp has a back pointer to this set when it is created
+	 *
+	 * The process for subflows is a little different to that of
+	 * a primary subflow/traditional tcp connection. We have already
+	 * allocated a new inp for the subflow, and do not want to create
+	 * a new socket based on the listen socket.
+	 *
+	 * Also the tp has already been attached (tcp_attach) to the inp,
+	 * so it should be safe to use inptotcpcb(inp) as the tcpcb is
+	 * already allocated.
+	 *
+	 */
+	so = inp->inp_socket;
+
+	/* unlocking the master inp */
+	INP_WUNLOCK(inp);
+
+//	SOCK_LOCK(so);
+
+	/* returns locked subflow inpcb */
+	inp = in_pcballoc_subflow(so, &V_tcbinfo);
+
+	error = tcp_subflow_attach(so, inp, mp);
+	if (error) {
+		in_pcbfree(inp);
+		goto abort;
+	}
+
+//	SOCK_UNLOCK(so);
+
+	inp->inp_inc.inc_flags = sc->sc_inc.inc_flags;
+	inp->inp_laddr = sc->sc_inc.inc_laddr;
+	inp->inp_lport = sc->sc_inc.inc_lport;
+
+	inp->inp_faddr = nam->sin_addr; //sc->sc_inc.inc_faddr;
+	inp->inp_fport = nam->sin_port;
+
+	INP_HASH_WLOCK(&V_tcbinfo);
+	in_pcbinshash(inp);
+	INP_HASH_WUNLOCK(&V_tcbinfo);
+
+	tp = intotcpcb(inp);
+	tp->iss = sc->sc_iss;
+	tp->irs = sc->sc_irs;
+
+	tcp_rcvseqinit(tp);
+	tcp_sendseqinit(tp);
+	tp->snd_wl1 = sc->sc_irs;
+	tp->snd_max = tp->iss + 1;
+	tp->snd_nxt = tp->iss + 1;
+	tp->rcv_up = sc->sc_irs + 1;
+	tp->rcv_wnd = sc->sc_wnd;
+	tp->rcv_adv += tp->rcv_wnd;
+	tp->last_ack_sent = tp->rcv_nxt;
+
+	tp->t_flags = sototcpcb(lso)->t_flags & (TF_NOPUSH|TF_NODELAY);
+	if (sc->sc_flags & SCF_NOOPT)
+		tp->t_flags |= TF_NOOPT;
+	else {
+		if (sc->sc_flags & SCF_WINSCALE) {
+			tp->t_flags |= TF_REQ_SCALE|TF_RCVD_SCALE;
+			tp->snd_scale = sc->sc_requested_s_scale;
+			tp->request_r_scale = sc->sc_requested_r_scale;
+		}
+		if (sc->sc_flags & SCF_TIMESTAMP) {
+			tp->t_flags |= TF_REQ_TSTMP|TF_RCVD_TSTMP;
+			tp->ts_recent = sc->sc_tsreflect;
+			tp->ts_recent_age = tcp_ts_getticks();
+			tp->ts_offset = sc->sc_tsoff;
+		}
+#ifdef TCP_SIGNATURE
+		if (sc->sc_flags & SCF_SIGNATURE)
+			tp->t_flags |= TF_SIGNATURE;
+#endif
+		if (sc->sc_flags & SCF_SACK)
+			tp->t_flags |= TF_SACK_PERMIT;
+	}
+
+	if (sc->sc_flags & SCF_ECN)
+		tp->t_flags |= TF_ECN_PERMIT;
+
+	tp->mp_active = 1;
+	tp->mpc = 1;
+	tp->t_state = TCPS_SYN_RECEIVED;
+
+	/*
+	 * Set up MSS and get cached values from tcp_hostcache.
+	 * This might overwrite some of the defaults we just set.
+	 */
+	tcp_mss(tp, sc->sc_peer_mss);
+
+	/*
+	 * If the SYN,ACK was retransmitted, reset cwnd to 1 segment.
+	 * NB: sc_rxmits counts all SYN,ACK transmits, not just retransmits.
+	 */
+	if (sc->sc_rxmits > 1)
+		tp->snd_cwnd = tp->t_maxseg;
+
+	/*
+	 * Copy and activate timers.
+	 */
+	tp->t_keepinit = sototcpcb(lso)->t_keepinit;
+	tp->t_keepidle = sototcpcb(lso)->t_keepidle;
+	tp->t_keepintvl = sototcpcb(lso)->t_keepintvl;
+	tp->t_keepcnt = sototcpcb(lso)->t_keepcnt;
+	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
+
+	INP_WUNLOCK(inp);
+
+	TCPSTAT_INC(tcps_accepts);
+
+	return (so);
+
+abort:
+//	SOCK_UNLOCK(so);
+	INP_WUNLOCK(inp);
+	return (NULL);
+}
+
 /*
  * This function gets called when we receive an ACK for a
  * socket in the LISTEN state.  We look up the connection
@@ -1009,7 +1218,149 @@
 	else
 		TCPSTAT_INC(tcps_sc_completed);
 
-/* how do we find the inp for the new socket? */
+	if (sc != &scs)
+		syncache_free(sc);
+	return (1);
+failed:
+	if (sc != NULL && sc != &scs)
+		syncache_free(sc);
+	if (s != NULL)
+		free(s, M_TCPLOG);
+	*lsop = NULL;
+	return (0);
+}
+
+/*
+ * XXXNJW: TBD
+ */
+int
+syncache_expand_subflow(struct in_conninfo *inc, struct tcpopt *to, struct tcphdr *th,
+    struct socket **lsop, struct mbuf *m)
+{
+	struct syncache *sc;
+	struct syncache_head *sch;
+	struct syncache scs;
+	char *s;
+
+	struct ip *ip;
+	ip = mtod(m, struct ip *);
+
+	/*
+	 * Global TCP locks are held because we manipulate the PCB lists
+	 * and create a new socket.
+	 */
+	INP_INFO_WLOCK_ASSERT(&V_tcbinfo);
+	KASSERT((th->th_flags & (TH_RST|TH_ACK|TH_SYN)) == TH_ACK,
+	    ("%s: can handle only ACK", __func__));
+	sc = syncache_lookup(inc, &sch);	/* returns locked sch */
+	SCH_LOCK_ASSERT(sch);
+
+	if (sc == NULL) {
+
+		/*
+		 * There is no syncache entry, so see if this ACK is
+		 * a returning syncookie.  To do this, first:
+		 *  A. See if this socket has had a syncache entry dropped in
+		 *     the past.  We don't want to accept a bogus syncookie
+		 *     if we've never received a SYN.
+		 *  B. check that the syncookie is valid.  If it is, then
+		 *     cobble up a fake syncache entry, and return.
+		 */
+		if (!V_tcp_syncookies) {
+			SCH_UNLOCK(sch);
+			if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+				log(LOG_DEBUG, "%s; %s: Spurious ACK, "
+				    "segment rejected (syncookies disabled)\n",
+				    s, __func__);
+			goto failed;
+		}
+		bzero(&scs, sizeof(scs));
+		sc = syncookie_lookup(inc, sch, &scs, to, th, *lsop);
+		SCH_UNLOCK(sch);
+		if (sc == NULL) {
+			if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+				log(LOG_DEBUG, "%s; %s: Segment failed "
+				    "SYNCOOKIE authentication, segment rejected "
+				    "(probably spoofed)\n", s, __func__);
+			goto failed;
+		}
+	} else {
+		/* Pull out the entry to unlock the bucket row. */
+		TAILQ_REMOVE(&sch->sch_bucket, sc, sc_hash);
+		sch->sch_length--;
+#ifdef TCP_OFFLOAD
+		if (ADDED_BY_TOE(sc)) {
+			struct toedev *tod = sc->sc_tod;
+
+			tod->tod_syncache_removed(tod, sc->sc_todctx);
+		}
+#endif
+		V_tcp_syncache.cache_count--;
+		SCH_UNLOCK(sch);
+	}
+
+	/*
+	 * Segment validation:
+	 * ACK must match our initial sequence number + 1 (the SYN|ACK).
+	 */
+	if (th->th_ack != sc->sc_iss + 1) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: ACK %u != ISS+1 %u, segment "
+			    "rejected\n", s, __func__, th->th_ack, sc->sc_iss);
+		goto failed;
+	}
+
+	/*
+	 * The SEQ must fall in the window starting at the received
+	 * initial receive sequence number + 1 (the SYN).
+	 */
+	if (SEQ_LEQ(th->th_seq, sc->sc_irs) ||
+	    SEQ_GT(th->th_seq, sc->sc_irs + sc->sc_wnd)) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: SEQ %u != IRS+1 %u, segment "
+			    "rejected\n", s, __func__, th->th_seq, sc->sc_irs);
+		goto failed;
+	}
+
+	if (!(sc->sc_flags & SCF_TIMESTAMP) && (to->to_flags & TOF_TS)) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: Timestamp not expected, "
+			    "segment rejected\n", s, __func__);
+		goto failed;
+	}
+	/*
+	 * If timestamps were negotiated the reflected timestamp
+	 * must be equal to what we actually sent in the SYN|ACK.
+	 */
+	if ((to->to_flags & TOF_TS) && to->to_tsecr != sc->sc_ts) {
+		if ((s = tcp_log_addrs(inc, th, NULL, NULL)))
+			log(LOG_DEBUG, "%s; %s: TSECR %u != TS %u, "
+			    "segment rejected\n",
+			    s, __func__, to->to_tsecr, sc->sc_ts);
+		goto failed;
+	}
+
+	struct sockaddr_in nam;
+	nam.sin_family = AF_INET;
+	nam.sin_port = th->th_sport;
+	nam.sin_addr = ip->ip_src;
+	nam.sin_len = sizeof(struct sockaddr_in);
+
+	/* debug output for addresses */
+	char buf[128];
+	inet_ntop(AF_INET, &ip->ip_src, buf, sizeof(buf));
+	mp_debug(MPSESSION, 4, 0, "%s: ip header from %s port %d to ",
+	    __func__, buf, ntohs(th->th_sport));
+	inet_ntop(AF_INET, &ip->ip_dst, buf, sizeof(buf));
+	mp_debug(MPSESSION, 4, 0, "%s port %d\n", buf, ntohs(th->th_dport));
+
+	*lsop = syncache_socket_subflow(sc, *lsop, m, &nam);
+
+	if (*lsop == NULL)
+		TCPSTAT_INC(tcps_sc_aborted);
+	else
+		TCPSTAT_INC(tcps_sc_completed);
+
 	if (sc != &scs)
 		syncache_free(sc);
 	return (1);
@@ -1069,8 +1420,9 @@
 	 */
 	so = *lsop;
 	tp = sototcpcb(so);
-	cred = crhold(so->so_cred);
 
+	cred = crhold(so->so_cred);											// doesn't look like it changes the master_tp or socket
+																		// could leave as-is for now.
 #ifdef INET6
 	if ((inc->inc_flags & INC_ISIPV6) &&
 	    (inp->inp_flags & IN6P_AUTOFLOWLABEL))
@@ -1277,6 +1629,35 @@
 	if (to->to_flags & TOF_SIGNATURE || ltflags & TF_SIGNATURE)
 		sc->sc_flags |= SCF_SIGNATURE;
 #endif
+	sc->mpc = 0;
+	sc->sent_capable = 0;
+	sc->is_master_subflow = 1;
+
+	/*
+	 * MP SYN packets are either the start of a new connection
+	 * (MP_CAPABLE) or the addition of a subflow to an existing
+	 * connection (MP_JOIN).
+	 */
+	if (to->to_flags & TOF_MPTCP) {
+		if(to->to_mopts.mpo_flags & MPOF_MP_CAPABLE) {
+			sc->sc_flags |= SCF_MPTCP;
+			sc->sc_mp_flags |= MPF_MP_CAPABLE;
+			sc->sc_mp_remote_key = to->to_mopts.remote_key;
+			sc->sc_mp_local_key = mp_generate_local_key();
+			sc->mpc = 1;
+			if (to->to_mopts.mpo_flags & MPOF_USE_CSUM)
+				sc->csum_enabled = 1;
+		} else if(to->to_mopts.mpo_flags & MPOF_JOIN_SYN) {
+			sc->sc_flags |= SCF_MPTCP;
+			sc->sc_mp_flags |= MPF_MP_JOIN;
+			sc->sc_mp_token = to->to_mopts.rcv_token;
+			sc->sc_local_rand = arc4random();
+			sc->sc_remote_rand = to->to_mopts.snd_rnd;
+			sc->is_master_subflow = 0;
+			sc->mpc = 1;
+		}
+	}
+
 	if (to->to_flags & TOF_SACKPERM)
 		sc->sc_flags |= SCF_SACK;
 	if (to->to_flags & TOF_MSS)
@@ -1300,7 +1681,6 @@
 #endif
 	}
 	SCH_UNLOCK(sch);
-
 	/*
 	 * Do a standard 3-way handshake.
 	 */
@@ -1429,11 +1809,11 @@
 	th->th_win = htons(sc->sc_wnd);
 	th->th_urp = 0;
 
+
 	if (sc->sc_flags & SCF_ECN) {
 		th->th_flags |= TH_ECE;
 		TCPSTAT_INC(tcps_ecn_shs);
 	}
-
 	/* Tack on the TCP options. */
 	if ((sc->sc_flags & SCF_NOOPT) == 0) {
 		to.to_flags = 0;
@@ -1450,14 +1830,45 @@
 			to.to_tsecr = sc->sc_tsreflect;
 			to.to_flags |= TOF_TS;
 		}
+		if(sc->sc_flags & SCF_MPTCP) {
+			to.to_mopts.mpo_flags = 0;
+			/* Got a SYN with MP_CAPABLE, so send MP_CAPABLE back */
+			if(sc->sc_mp_flags & MPF_MP_CAPABLE) {
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |=
+						MPOF_CAPABLE_SYN;
+				to.to_mopts.local_key = sc->sc_mp_local_key;
+
+				if (sc->csum_enabled)
+					to.to_mopts.mpo_flags |= MPOF_USE_CSUM;
+			}
+			/* Got a valid MP_JOIN, send MP_JOIN SYN/ACK back */
+			if(sc->sc_mp_flags & MPF_MP_JOIN) {
+				// include addressID?
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |=
+						MPOF_JOIN_SYN;
+				to.to_mopts.to_mpoptlen =
+						MPTCP_SUBLEN_MP_JOIN_SYNACK;
+				to.to_mopts.snd_rnd = sc->sc_local_rand;
+				to.to_mopts.truncated_MAC = 0;			// XXXNJW should do MAC calculation somewhere
+			}
+		}
 		if (sc->sc_flags & SCF_SACK)
 			to.to_flags |= TOF_SACKPERM;
 #ifdef TCP_SIGNATURE
 		if (sc->sc_flags & SCF_SIGNATURE)
 			to.to_flags |= TOF_SIGNATURE;
 #endif
+		uint64_t mpof_flags = to.to_mopts.mpo_flags;
 		optlen = tcp_addoptions(&to, (u_char *)(th + 1));
 
+		/* If mp_capable was set and is now unset, then it has
+		 * been added as an option on the outgoing SYN/ACK */
+		if ((mpof_flags & MPOF_CAPABLE_SYN) &&
+		    (!to.to_mopts.mpo_flags & MPOF_CAPABLE_SYN))
+			sc->sent_capable = 1;
+
 		/* Adjust headers by option size. */
 		th->th_off = (sizeof(struct tcphdr) + optlen) >> 2;
 		m->m_len += optlen;
@@ -1838,3 +2249,29 @@
 	*pcbs_exported = count;
 	return error;
 }
+
+/* Find inp matching addresses and return locked */
+static inline struct inpcb*
+inp_lookup(struct in_addr *faddr, struct in_addr *laddr, uint16_t fport,
+    uint16_t lport) {
+	struct inpcb *inp = NULL;
+	struct tcpcb *tp = NULL;
+
+	INP_INFO_LOCK_ASSERT(&V_tcbinfo);
+	LIST_FOREACH(inp, &V_tcb, inp_list) {
+		INP_WLOCK(inp);
+		/* Important to skip tcptw structs. */
+		if (!(inp->inp_flags & INP_TIMEWAIT) &&
+			(tp = intotcpcb(inp)) != NULL) {
+				if (inp->inp_faddr.s_addr == faddr->s_addr &&
+					inp->inp_laddr.s_addr == laddr->s_addr &&
+					inp->inp_fport == fport &&
+					inp->inp_lport == lport) {
+					break;
+				}
+		}
+		INP_WUNLOCK(inp);
+	}
+
+	return(inp);
+}
diff -r 11a8f1275a38 sys/netinet/tcp_syncache.h
--- a/sys/netinet/tcp_syncache.h	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_syncache.h	Mon Mar 11 02:59:51 2013 +1100
@@ -41,6 +41,8 @@
 void	 syncache_unreach(struct in_conninfo *, struct tcphdr *);
 int	 syncache_expand(struct in_conninfo *, struct tcpopt *,
 	     struct tcphdr *, struct socket **, struct mbuf *);
+int	 syncache_expand_subflow(struct in_conninfo *, struct tcpopt *,
+	     struct tcphdr *, struct socket **, struct mbuf *);
 void	 syncache_add(struct in_conninfo *, struct tcpopt *,
 	     struct tcphdr *, struct inpcb *, struct socket **, struct mbuf *,
 	     void *, void *);
@@ -76,6 +78,21 @@
 	struct ucred	*sc_cred;		/* cred cache for jail checks */
 
 	u_int32_t	sc_spare[2];		/* UTO */
+
+	/* MULTIPATH */
+	uint64_t	sc_ds_iss;	/* initial data sequence num */
+	uint64_t	sc_ds_irs;
+	u_int64_t	sc_mp_remote_key;
+	u_int64_t	sc_mp_local_key;
+	uint32_t 	sc_local_rand;	/* random number for join MAC */
+	uint32_t 	sc_remote_rand;	/* random number for join MAC */
+	uint32_t	sc_mp_token;	/* token for the multipath session */
+	uint8_t mpc:1,			/* other end supports mptcp */
+			sent_capable:1,	/* sent mp_cable */
+			csum_enabled:1,
+			is_master_subflow:1;
+	uint8_t		sc_mp_flags;	/* flags for mp subtype */
+	struct	mpcb *t_mpcb;		/* back pointer to multipath cb */
 };
 
 /*
@@ -87,12 +104,20 @@
 						/* MSS is implicit */
 #define SCF_UNREACH	0x10			/* icmp unreachable received */
 #define SCF_SIGNATURE	0x20			/* send MD5 digests */
+#define	SCF_MPTCP	0x40			/* MPTCP capable */
 #define SCF_SACK	0x80			/* send SACK option */
 #define SCF_ECN		0x100			/* send ECN setup packet */
 
 #define	SYNCOOKIE_SECRET_SIZE	8	/* dwords */
 #define	SYNCOOKIE_LIFETIME	16	/* seconds */
 
+
+/*
+ * Flags for sc_mp_flags
+ */
+#define MPF_MP_CAPABLE	0x01
+#define MPF_MP_JOIN		0x02
+
 struct syncache_head {
 	struct vnet	*sch_vnet;
 	struct mtx	sch_mtx;
diff -r 11a8f1275a38 sys/netinet/tcp_usrreq.c
--- a/sys/netinet/tcp_usrreq.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_usrreq.c	Mon Mar 11 02:59:51 2013 +1100
@@ -46,10 +46,15 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/limits.h>
+#include <sys/endian.h>
+#include <sys/lock.h>
 #include <sys/malloc.h>
+#include <sys/mutex.h>
 #include <sys/kernel.h>
 #include <sys/sysctl.h>
 #include <sys/mbuf.h>
+#include <sys/queue.h>
+
 #ifdef INET6
 #include <sys/domain.h>
 #endif /* INET6 */
@@ -79,10 +84,13 @@
 #include <netinet6/ip6_var.h>
 #include <netinet6/scope6_var.h>
 #endif
+
 #include <netinet/tcp_fsm.h>
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
 #include <netinet/tcpip.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
@@ -170,6 +178,7 @@
 
 	tp = intotcpcb(inp);
 
+
 	if (inp->inp_flags & INP_TIMEWAIT) {
 		/*
 		 * There are two cases to handle: one in which the time wait
@@ -369,7 +378,7 @@
 	if (error == 0) {
 		tp->t_state = TCPS_LISTEN;
 		solisten_proto(so, backlog);
-#ifdef TCP_OFFLOAD
+#ifdef TCP_OFFLOAD		
 		tcp_offload_listen_start(tp);
 #endif
 	}
@@ -382,6 +391,45 @@
 }
 #endif /* INET */
 
+
+/*
+ * Prepare a subflow to accept connections.
+ * XXXNJW: This is currently called as SYNs arrive on
+ * subflow addresses.
+ */
+int
+tcp_do_subflow_listen(struct inpcb *inp, struct thread *td)
+{
+	int error = 0;
+	struct tcpcb *tp = NULL;
+
+	TCPDEBUG0;
+	KASSERT(inp != NULL, ("tcp_do_subflow_listen: inp == NULL"));
+	INP_WLOCK_ASSERT(inp);
+	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
+		error = EINVAL;
+		goto out;
+	}
+	tp = intotcpcb(inp);
+	TCPDEBUG1();
+	INP_HASH_WLOCK(&V_tcbinfo);
+	if (error == 0 && inp->inp_lport == 0)
+		error = in_pcbbind(inp, (struct sockaddr *)0, td->td_ucred);
+	else
+		error = in_pcbinshash(inp);
+	INP_HASH_WUNLOCK(&V_tcbinfo);
+	if (error == 0) {
+		tp->t_state = TCPS_LISTEN;
+#ifdef TCP_OFFLOAD
+		tcp_offload_listen_start(tp);
+#endif
+	}
+
+out:
+	TCPDEBUG2(PRU_LISTEN);
+	return (error);
+}
+
 #ifdef INET6
 static int
 tcp6_usr_listen(struct socket *so, int backlog, struct thread *td)
@@ -433,18 +481,103 @@
  * Enter SYN_SENT state, and mark socket as connecting.
  * Start keep-alive timer, and seed output sequence space.
  * Send initial segment on connection.
+ *
+ *
  */
 static int
 tcp_usr_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
 	int error = 0;
 	struct inpcb *inp;
+	struct inpcb *master_inp;
+	struct mpcb *mp;
 	struct tcpcb *tp = NULL;
 	struct sockaddr_in *sinp;
 
 	sinp = (struct sockaddr_in *)nam;
 	if (nam->sa_len != sizeof (*sinp))
 		return (EINVAL);
+
+	/*
+	 * Must disallow TCP ``connections'' to multicast addresses.
+	 */
+	if (sinp->sin_family == AF_INET
+	    && IN_MULTICAST(ntohl(sinp->sin_addr.s_addr)))
+		return (EAFNOSUPPORT);
+	if ((error = prison_remote_ip4(td->td_ucred, &sinp->sin_addr)) != 0)
+		return (error);
+
+	TCPDEBUG0;
+
+	//XXXNJW: need to find a more robust method of determining the
+	//subflow inpcb.
+
+	master_inp = sotoinpcb(so);
+	KASSERT(master_inp != NULL, ("tcp_usr_connect: master_inp == NULL"));
+
+	mp = sototcpcb(so)->t_mpcb;
+
+	/*
+	 * If the socket has just been initialised, this is the
+	 * creation of the master subflow, so we can use the macros.
+	 * Else get pcb's of the first subflow in the list (the first
+	 * subflow is the most recently added subflow)
+	 */
+	if (so->so_state == 0) {
+		inp = sotoinpcb(so);
+		tp = intotcpcb(inp);
+		INP_WLOCK(inp);
+	}
+	else {
+		tp = (SLIST_FIRST(&mp->tp_list));
+		KASSERT(tp != NULL, ("tcp_usr_connect: subflow tp == NULL"));
+		inp = tp->t_inpcb;
+		INP_WLOCK_ASSERT(inp); // locked in the join task handler
+	}
+
+	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
+		error = EINVAL;
+		goto out;
+	}
+
+	TCPDEBUG1();
+
+	if(so->so_state == 0) {
+		if ((error = tcp_connect(tp, nam, td)) != 0)
+			goto out;
+	} else {
+		if ((error = tcp_subflow_connect(tp, nam, td)) != 0)
+			goto out;
+	}
+
+#ifdef TCP_OFFLOAD
+	if (registered_toedevs > 0 &&
+	    (error = tcp_offload_connect(so, nam)) == 0)
+		goto out;
+#endif
+	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
+	error = tcp_output(tp);
+
+out:
+	TCPDEBUG2(PRU_CONNECT);
+	INP_WUNLOCK(inp);
+	return (error);
+}
+#endif /* INET */
+
+/*
+ * nam is the foreign address. Also set the local
+ */
+int
+mp_accept_subflow_connection(struct inpcb *inp, struct sockaddr *nam, struct thread *td) {
+	int error = 0;
+	//struct inpcb *inp;
+	struct tcpcb *tp;
+	struct sockaddr_in *sinp;
+
+	sinp = (struct sockaddr_in *)nam;
+	if (nam->sa_len != sizeof (*sinp))
+		return (EINVAL);
 	/*
 	 * Must disallow TCP ``connections'' to multicast addresses.
 	 */
@@ -455,7 +588,6 @@
 		return (error);
 
 	TCPDEBUG0;
-	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("tcp_usr_connect: inp == NULL"));
 	INP_WLOCK(inp);
 	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
@@ -463,22 +595,17 @@
 		goto out;
 	}
 	tp = intotcpcb(inp);
+
 	TCPDEBUG1();
-	if ((error = tcp_connect(tp, nam, td)) != 0)
-		goto out;
-#ifdef TCP_OFFLOAD
-	if (registered_toedevs > 0 &&
-	    (error = tcp_offload_connect(so, nam)) == 0)
-		goto out;
-#endif
-	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
-	error = tcp_output(tp);
+
+	tp->t_state = TCPS_SYN_RECEIVED;
+
 out:
 	TCPDEBUG2(PRU_CONNECT);
 	INP_WUNLOCK(inp);
 	return (error);
 }
-#endif /* INET */
+
 
 #ifdef INET6
 static int
@@ -577,25 +704,33 @@
 static int
 tcp_usr_disconnect(struct socket *so)
 {
-	struct inpcb *inp;
-	struct tcpcb *tp = NULL;
 	int error = 0;
+	struct inpcb *sf_inp;
+	struct mpcb *mp;
+	struct tcpcb *sf_tp;
+
+	sf_tp = sototcpcb(so);
+	mp = sf_tp->t_mpcb;
 
 	TCPDEBUG0;
 	INP_INFO_WLOCK(&V_tcbinfo);
-	inp = sotoinpcb(so);
-	KASSERT(inp != NULL, ("tcp_usr_disconnect: inp == NULL"));
-	INP_WLOCK(inp);
-	if (inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
-		error = ECONNRESET;
-		goto out;
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		sf_inp = sf_tp->t_inpcb;
+		KASSERT(sf_inp != NULL, ("tcp_usr_disconnect: inp == NULL"));
+		INP_WLOCK(sf_inp);
+		if (sf_inp->inp_flags & (INP_TIMEWAIT | INP_DROPPED)) {
+			error = ECONNRESET;
+			TCPDEBUG2(PRU_DISCONNECT);
+			INP_WUNLOCK(sf_inp);
+			goto out;
+		}
+		sf_tp = intotcpcb(sf_inp);
+		TCPDEBUG1();
+		tcp_disconnect(sf_tp);
+		TCPDEBUG2(PRU_DISCONNECT);
+		INP_WUNLOCK(sf_inp);
 	}
-	tp = intotcpcb(inp);
-	TCPDEBUG1();
-	tcp_disconnect(tp);
 out:
-	TCPDEBUG2(PRU_DISCONNECT);
-	INP_WUNLOCK(inp);
 	INP_INFO_WUNLOCK(&V_tcbinfo);
 	return (error);
 }
@@ -978,19 +1113,20 @@
 	INP_INFO_WLOCK(&V_tcbinfo);
 	INP_WLOCK(inp);
 	KASSERT(inp->inp_socket != NULL,
-	    ("tcp_usr_close: inp_socket == NULL"));
+		("tcp_usr_close: inp_socket == NULL"));
 
 	/*
 	 * If we still have full TCP state, and we're not dropped, initiate
 	 * a disconnect.
 	 */
 	if (!(inp->inp_flags & INP_TIMEWAIT) &&
-	    !(inp->inp_flags & INP_DROPPED)) {
+		!(inp->inp_flags & INP_DROPPED)) {
 		tp = intotcpcb(inp);
 		TCPDEBUG1();
 		tcp_disconnect(tp);
 		TCPDEBUG2(PRU_CLOSE);
 	}
+
 	if (!(inp->inp_flags & INP_DROPPED)) {
 		SOCK_LOCK(so);
 		so->so_state |= SS_PROTOREF;
@@ -1107,6 +1243,8 @@
 	u_short lport;
 	int error;
 
+	struct mpcb *mp;
+
 	INP_WLOCK_ASSERT(inp);
 	INP_HASH_WLOCK(&V_tcbinfo);
 
@@ -1147,6 +1285,116 @@
 	soisconnecting(so);
 	TCPSTAT_INC(tcps_connattempt);
 	tp->t_state = TCPS_SYN_SENT;
+	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
+	tp->iss = tcp_new_isn(tp);
+	tcp_sendseqinit(tp);
+
+	/*
+	 * Create new multipath control block. for the connection
+	 * inp and socket are set in mp_newmpcb
+	 */
+	mp = mp_newmpcb(inp);
+	mp->master_tcpcb = tp;
+
+	/* add subflow tp to tp_list */
+	SLIST_INSERT_HEAD(&mp->tp_list, mp->master_tcpcb, next_subflow);
+
+	mp->subflow_cnt = 1;
+	tp->t_mpcb = mp;
+
+	/* should have a sysctl to check if we want to enable */
+	tp->mp_enabled = 1;
+	tp->t_mpcb->direct_map = 1;
+
+	STAILQ_INSERT_TAIL(&mp->sf_reass_queues_list, tp->t_segq, tqe_next_head);
+
+	if (tp->t_mpcb->mp_state == MPS_CLOSED) {
+		mp_process_local_key(tp->t_mpcb, mp_generate_local_key());
+
+		/* Always start in direct mapping mode */
+		tp->t_mpcb->ds_map_max = tp->t_mpcb->ds_map_min = tp->t_mpcb->ds_snd_una = tp->iss + 1;
+		tp->t_mpcb->mp_state = MPS_SYN_SENT;
+
+		/* initialise mutex for control block */
+		mtx_init(&mp->mpcb_mutex, "mpcb", NULL, MTX_DEF);
+	}
+
+	return 0;
+
+out:
+	INP_HASH_WUNLOCK(&V_tcbinfo);
+	return (error);
+}
+#endif /* INET */
+
+
+/*
+ * Common subroutine to open a TCP connection to remote host specified
+ * by struct sockaddr_in in mbuf *nam.  Call in_pcbbind to assign a local
+ * port number if needed.  Call in_pcbconnect_setup to do the routing and
+ * to choose a local host address (interface).  If there is an existing
+ * incarnation of the same connection in TIME-WAIT state and if the remote
+ * host was sending CC options and if the connection duration was < MSL, then
+ * truncate the previous TIME-WAIT state and proceed.
+ * Initialize connection parameters and enter SYN-SENT state.
+ */
+int
+tcp_subflow_connect(struct tcpcb *tp, struct sockaddr *nam, struct thread *td)
+{
+	struct inpcb *inp = tp->t_inpcb, *oinp;
+	struct in_addr laddr;
+	u_short lport;
+	int error = 0;
+
+	INP_WLOCK_ASSERT(inp);
+	INP_HASH_WLOCK(&V_tcbinfo);
+
+	/*
+	 * If lport == 0., set an ephemeral port number. otherise we just
+	 * add directly into hash list.
+	 */
+	if (inp->inp_lport == 0) {
+		error = in_pcbbind(inp, (struct sockaddr *)0, td->td_ucred);
+	} else {
+		error = in_pcbinshash(inp);
+		mp_debug(MPSESSION, 4, 0, "%s: in_pcbhash error %d\n", __func__, error);
+	}
+	if (error)
+		goto out;
+
+	/*
+	 * Cannot simply call in_pcbconnect, because there might be an
+	 * earlier incarnation of this same connection still in
+	 * TIME_WAIT state, creating an ADDRINUSE error.
+	 */
+	laddr = inp->inp_laddr;
+	lport = inp->inp_lport;
+	error = in_pcbconnect_setup(inp, nam, &laddr.s_addr, &lport,
+	    &inp->inp_faddr.s_addr, &inp->inp_fport, &oinp, td->td_ucred);
+
+	if (error && oinp == NULL) {
+		goto out;
+	}
+	if (oinp) {
+		error = EADDRINUSE;
+		goto out;
+	}
+	inp->inp_laddr = laddr;
+	in_pcbrehash(inp);
+	INP_HASH_WUNLOCK(&V_tcbinfo);
+
+	/*
+	 * Compute window scaling to request:
+	 * Scale to fit into sweet spot.  See tcp_syncache.c.
+	 * XXX: This should move to tcp_output().
+	 */
+	while (tp->request_r_scale < TCP_MAX_WINSHIFT &&
+	    (TCP_MAXWIN << tp->request_r_scale) < sb_max)
+		tp->request_r_scale++;
+
+	TCPSTAT_INC(tcps_connattempt);
+	tp->t_state = TCPS_SYN_SENT;
+	tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
 	tp->iss = tcp_new_isn(tp);
 	tcp_sendseqinit(tp);
 
@@ -1156,7 +1404,6 @@
 	INP_HASH_WUNLOCK(&V_tcbinfo);
 	return (error);
 }
-#endif /* INET */
 
 #ifdef INET6
 static int
@@ -1219,6 +1466,7 @@
 	soisconnecting(so);
 	TCPSTAT_INC(tcps_connattempt);
 	tp->t_state = TCPS_SYN_SENT;
+	//tcp_timer_activate(tp, TT_KEEP, TP_KEEPINIT(tp));
 	tp->iss = tcp_new_isn(tp);
 	tcp_sendseqinit(tp);
 
@@ -1591,8 +1839,9 @@
 static int
 tcp_attach(struct socket *so)
 {
+	struct inpcb *inp;
 	struct tcpcb *tp;
-	struct inpcb *inp;
+
 	int error;
 
 	if (so->so_snd.sb_hiwat == 0 || so->so_rcv.sb_hiwat == 0) {
@@ -1602,6 +1851,7 @@
 	}
 	so->so_rcv.sb_flags |= SB_AUTOSIZE;
 	so->so_snd.sb_flags |= SB_AUTOSIZE;
+	so->so_snd.sb_flags |= SB_DEFERACCT;
 	INP_INFO_WLOCK(&V_tcbinfo);
 	error = in_pcballoc(so, &V_tcbinfo);
 	if (error) {
@@ -1617,6 +1867,7 @@
 	else
 #endif
 	inp->inp_vflag |= INP_IPV4;
+
 	tp = tcp_newtcpcb(inp);
 	if (tp == NULL) {
 		in_pcbdetach(inp);
@@ -1631,6 +1882,42 @@
 }
 
 /*
+ * Attach TCP protocol to subflow inp, allocating
+ * buffer space, and entering LISTEN state.
+ */
+int
+tcp_subflow_attach(struct socket *so, struct inpcb *inp, struct mpcb *mp)
+{
+	struct tcpcb *tp;
+
+	INP_WLOCK_ASSERT(inp);
+#ifdef INET6
+	if (inp->inp_vflag & INP_IPV6PROTO) {
+		inp->inp_vflag |= INP_IPV6;
+		inp->in6p_hops = -1;	/* use kernel default */
+	}
+	else
+#endif
+	inp->inp_vflag |= INP_IPV4;
+
+	tp = tcp_newtcpcb(inp);
+
+	if (tp == NULL) {
+		return (ENOBUFS);
+	}
+	/* Increase subflow count in mp and add to list of subflow blocks */
+	mp->subflow_cnt += 1;
+	SLIST_INSERT_HEAD(&mp->tp_list, tp, next_subflow);
+	tp->t_mpcb = mp;
+
+	/* Subflows only join mp-enabled sessions */
+	tp->mp_enabled = 1;
+
+	tp->t_state = TCPS_CLOSED;
+	return 0;
+}
+
+/*
  * Initiate (or continue) disconnect.
  * If embryonic state, just send reset (once).
  * If in ``let data drain'' option and linger null, just drop.
@@ -1708,7 +1995,7 @@
 		break;
 
 	case TCPS_ESTABLISHED:
-		tp->t_state = TCPS_FIN_WAIT_1;
+		tp->t_state = TCPS_FIN_WAIT_1;			//XXXNJW should be set after all DS-level is acked
 		break;
 
 	case TCPS_CLOSE_WAIT:
@@ -1924,7 +2211,7 @@
 
 	db_print_indent(indent);
 	db_printf("t_segq first: %p   t_segqlen: %d   t_dupacks: %d\n",
-	   LIST_FIRST(&tp->t_segq), tp->t_segqlen, tp->t_dupacks);
+	   TAILQ_FIRST(tp->t_segq), tp->t_segqlen, tp->t_dupacks);
 
 	db_print_indent(indent);
 	db_printf("tt_rexmt: %p   tt_persist: %p   tt_keep: %p\n",
